unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, IBConnection, sqldb, db, FileUtil, Forms, Controls,
  Graphics, Dialogs, ComCtrls, DbCtrls, DBGrids;

type

  { TForm1 }

  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    IBConnection1: TIBConnection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    ToolBar1: TToolBar;
    BtnChangeCount: TToolButton;
    btnSave: TToolButton;
    BtnUpdateStatus: TToolButton;
    ToolButton2: TToolButton;
    procedure btnSaveClick(Sender: TObject);
    procedure BtnUpdateStatusClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnChangeCountClick(Sender: TObject);
  private
    { private declarations }
    procedure Savechanges;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  IBConnection1.Connected:=true;
  SQLQuery1.Active:=IBConnection1.Connected;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  if SQLTransaction1.Active and
    (SQLQuery1.ChangeCount>0) and
    //Ist immer false: SQLQuery1.Modified and
    (MessageDlg('Änderungen speichern?', mtConfirmation, [mbYes, mbNo],0) = mrYes)
    then
     Savechanges
  else if SQLTransaction1.Active then SQLTransaction1.Rollback;
end;

procedure TForm1.btnSaveClick(Sender: TObject);
begin
  Savechanges;
end;

procedure TForm1.BtnUpdateStatusClick(Sender: TObject);
begin
  case SQLQuery1.UpdateStatus of
   usUnmodified: Caption:='usUnmodified';
   usModified: Caption:='usModified';
   usInserted: Caption:='usInserted';
   usDeleted: Caption:='usDeleted';
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SQLQuery1.Active:=false;
  IBConnection1.Connected:=false;
end;

procedure TForm1.BtnChangeCountClick(Sender: TObject);
begin
  Caption:='ChangeCount: '+IntToSTr(SQLQuery1.ChangeCount);
  if SQLQuery1.Modified then Caption:=Caption+' Modified';
end;

procedure TForm1.Savechanges;
// Saves edits done by user, if any.
begin
  try
    if SQLTransaction1.Active then
    // Only if we are within a started transaction
    // otherwise you get "Operation cannot be performed on an inactive dataset"
    begin
      SQLQuery1.ApplyUpdates; //Pass user-generated changes back to database...
      SQLTransaction1.Commit; //... and commit them using the transaction.
      //SQLTransaction1.Active now is false

      SQLQuery1.Active:=true;
    end;
  except
  on E: EDatabaseError do
    begin
      MessageDlg('Error', 'A database error has occurred. Technical error message: ' +
        E.Message, mtError, [mbOK], 0);
      //Edit1.Text := '';
    end;
  end;
end;
end.

